﻿#include <iostream>
#include <vector>
#include <stdio.h>
#include <string>


typedef struct _test_struct
{
    unsigned char id;
    bool operator == (const _test_struct &e) const
    {
        return (e.id == id);
    }
} test_struct;

std::vector <test_struct> elements;

bool test2(test_struct *el)
{
    std::cout << "test2 start" << std::endl;
    std::vector <test_struct>::const_iterator i;
    for (i = elements.begin(); i < elements.end(); i++)
    {
        if (*i == *el){
            std::cout << "test2 finish" << std::endl;
            return true;
        }
    }
    std::cout << "test2 finish " << std::endl;
    return false;
}

bool test1(const void* data, const size_t len, const int param)
{
    test_struct *tmp = (test_struct *) data;

    while((unsigned char*)tmp < (len + (unsigned char*)data))
    {
        if (!test2(tmp)) {
            switch (param)
            {
            case 1: {
                if (tmp->id == 1)
                    return false;
                break;
            }
            case 2:
            case 3 : {
                if (tmp->id == 2)
                    return false;
                break;
            }
            case 4: {
                return false;
            }
            case 5: {
                if (tmp->id == 3)
                    return false;
                break;
            }
            case 6: {
                if (tmp->id == 4)
                    return false;
                break;
            }
            default:
                return false;
            }
        }
        tmp++;
    }
    return true;
}

int main()
{
    std::string str("jalirfjru3eiwupi-03ir0");
    std::cout << "test1 start" << std::endl;
    test1(str.c_str(),sizeof(_test_struct)*2, 0);
    std::cout << "test1 finish" << std::endl;
    return 0;
}
